/*
	$Id: Constant.java 307 2007-03-22 21:08:11Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

package com.maroontress.sanctuary;

import org.w3c.dom.Element;
import java.io.PrintWriter;

/**
   󷿤Ǥ

   constantǤбޤ
*/
public class Constant {

    /** ̾ */
    private Strings name;

    /**  */
    private String value;

    /** descǤ */
    private Description desc;

    /**
       󷿤ޤ

       @param g 饹
       @param elem constant
    */
    public Constant(final Class g, final Element elem) {
	name = g.expandNS(elem, "name");
	value = elem.getAttribute("value");
	if (elem.getAttributeNode("value") != null && value.equals("")) {
	    String m = "empty value";
	    throw new NodeException(elem.getAttributeNode("value"), m);
	}

	ChildrenFilter c = new ChildrenFilter(elem);
	desc = new Description(c.getDirectChildrenByTagName("desc"));
    }

    /**
       ̾ޤ

       @return ̾
    */
    public Strings getName() {
	return name;
    }

    /**
       󷿤ΥФɽʸޤ

       ͤꤵƤʤ硢֤̾ޤǤ
        "̾ = " ֤ޤ

       @return 󷿤Υ
    */
    public String getCode() {
	String n = name.getFull();
	if (value.equals("")) {
	    return n;
	}
	return n + " = " + value;
    }

    /**
       HTMLǽϤޤ

       @param wr 饤
    */
    public void printSummary(final PrintWriter wr) {
	wr.println(""
+ "<tr>\n"
+ "  <td><a href=\"#" + name + "\"><b>" + name.getShorten() + "</b></a>"
+ "<br>"
+ "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
+ desc.getBriefText() + "</td>\n"
+ "</tr>");
    }

    /**
       ܺ٤HTMLǽϤޤ

       @param wr 饤
    */
    public void printDetail(final PrintWriter wr) {
	wr.println(""
+ "<dl><a name=\"" + name + "\"></a>" + name.getShorten() + "<dd>\n"
+ desc.getText() + "</dd></dl>");
    }

    /**
       ܺ٤TeXǽϤޤ

       @param wr 饤
    */
    public void printTexDetail(final PrintWriter wr) {
	wr.println(""
+ "\\item[{\\ttfamily " + Tex.safe(name.getShorten()) + "}]\n"
+ desc.getTexText());
    }
}
